import traceback

from cpl_core.console import Console

from bot_api.abc.dto_abc import DtoABC


class TokenDTO(DtoABC):

    def __init__(self, token: str, refresh_token: str):
        DtoABC.__init__(self)

        self._token = token
        self._refresh_token = refresh_token
        
    @property
    def token(self) -> str:
        return self._token
    
    @property
    def refresh_token(self) -> str:
        return self._refresh_token

    def from_dict(self, values: dict):
        self._token = values['Token']
        self._refresh_token = values['RefreshToken']

    def to_dict(self) -> dict:
        return {
            'Token': self._token,
            'RefreshToken': self._refresh_token
        }
