import traceback

from cpl_core.console import Console

from bot_api.abc.dto_abc import DtoABC
from bot_api.model.auth_user_dto import AuthUserDTO


class UpdateAuthUserDTO(DtoABC):

    def __init__(
            self,
            auth_user: AuthUserDTO,
            new_auth_user: AuthUserDTO,
            change_password=False
    ):
        DtoABC.__init__(self)

        self._auth_user = auth_user
        self._new_auth_user = new_auth_user
        self._change_password = change_password

    @property
    def auth_user(self) -> AuthUserDTO:
        return self._auth_user

    @property
    def new_auth_user(self) -> AuthUserDTO:
        return self._new_auth_user

    @property
    def change_password(self) -> bool:
        return self._change_password

    def from_dict(self, values: dict):
        self._auth_user = values['AuthUser']
        self._new_auth_user = values['NewAuthUser']
        self._change_password = False if 'ChangePassword' not in values else values['ChangePassword']

    def to_dict(self) -> dict:
        return {
            'AuthUser': self._auth_user,
            'NewAuthUser': self._new_auth_user,
            'ChangePassword': self._change_password
        }
