class Route:
    registered_routes = {}

    @classmethod
    def route(cls, path=None, **kwargs):
        # simple decorator for class based views
        def inner(fn):
            cls.registered_routes[path] = (fn, kwargs)
            return fn

        return inner

    @classmethod
    def get(cls, path=None, **kwargs):
        return cls.route(path, methods=['GET'], **kwargs)

    @classmethod
    def post(cls, path=None, **kwargs):
        return cls.route(path, methods=['POST'], **kwargs)

    @classmethod
    def head(cls, path=None, **kwargs):
        return cls.route(path, methods=['HEAD'], **kwargs)

    @classmethod
    def put(cls, path=None, **kwargs):
        return cls.route(path, methods=['PUT'], **kwargs)

    @classmethod
    def delete(cls, path=None, **kwargs):
        return cls.route(path, methods=['DELETE'], **kwargs)
