from bot_api.abc.auth_user_transformer_abc import AuthUserTransformerABC
from bot_api.model.auth_user_dto import AuthUserDTO
from bot_data.model.auth_user import AuthUser


class AuthUserTransformer(AuthUserTransformerABC):

    @staticmethod
    def to_db(dto: AuthUserDTO) -> AuthUser:
        return AuthUser(
            dto.first_name,
            dto.last_name,
            dto.email,
            dto.password,
            None,
            None,
            None,
            None,
            dto.auth_role,
            id=dto.id
        )

    @staticmethod
    def to_dto(db: AuthUser) -> AuthUserDTO:
        return AuthUserDTO(
            db.id,
            db.first_name,
            db.last_name,
            db.email,
            db.password,
            db.confirmation_id is None,
            db.auth_role
        )
