from bot_core.logging.database_logger import DatabaseLogger
from bot_data.abc.migration_abc import MigrationABC
from bot_data.db_context import DBContext


class ApiMigration(MigrationABC):
    name = '0.3_ApiMigration'

    def __init__(self, logger: DatabaseLogger, db: DBContext):
        MigrationABC.__init__(self)
        self._logger = logger
        self._db = db
        self._cursor = db.cursor

    def upgrade(self):
        self._logger.debug(__name__, 'Running upgrade')

        self._cursor.execute(
            str(f"""
            CREATE TABLE IF NOT EXISTS `AuthUsers` (
              `Id` bigint NOT NULL,
              `FirstName` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci,
              `LastName` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci,
              `EMail` varchar(255) DEFAULT NULL,
              `Password` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci,
              `RefreshToken` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci,
              `ConfirmationId` varchar(255) DEFAULT NULL,
              `ForgotPasswordId` varchar(255) DEFAULT NULL,
              `RefreshTokenExpiryTime` datetime(6) NOT NULL,
              `AuthRole` int NOT NULL DEFAULT '0'
              `CreatedOn` datetime(6) NOT NULL,
              `LastModifiedOn` datetime(6) NOT NULL,
            )
            """)
        )

    def downgrade(self):
        self._cursor.execute('DROP TABLE `AuthUsers`;')
